package no.ntnu.mycbr;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import de.dfki.mycbr.core.DefaultCaseBase;
import de.dfki.mycbr.core.Project;
import de.dfki.mycbr.core.casebase.Attribute;
import de.dfki.mycbr.core.casebase.Instance;
import de.dfki.mycbr.core.casebase.MultipleAttribute;
import de.dfki.mycbr.core.model.AttributeDesc;
import de.dfki.mycbr.core.model.Concept;
import de.dfki.mycbr.core.model.ConceptDesc;
import de.dfki.mycbr.core.model.SymbolDesc;
import de.dfki.mycbr.core.retrieval.Retrieval;
import de.dfki.mycbr.core.retrieval.Retrieval.RetrievalMethod;
import de.dfki.mycbr.core.similarity.AmalgamationFct;
import de.dfki.mycbr.core.similarity.Similarity;
import de.dfki.mycbr.util.Pair;

/**
 * Created by talep on 21.03.2017.
 */
public class selfbackTest {
    public static CBREngine engine;
    public static Project rec;
    public static DefaultCaseBase cb;
    public static DefaultCaseBase exercise_cb;
    public static Concept myConcept;


/*
    public static void main(String[] args) {

        engine = new CBREngine();
        rec = engine.createProjectFromPRJ();
        // create case bases and assign the case bases that will be used for submitting a query
        cb = (DefaultCaseBase)rec.getCaseBases().get("Example_CB");
        exercise_cb = (DefaultCaseBase) rec.getCaseBases().get("Exercise");
        // create a concept and get the main concept of the project;
        myConcept = rec.getConceptByID("Case");

        // list new cases
        System.out.println("Global sim: "+ myConcept.getActiveAmalgamFct().getName());
        System.out.println("all sim: "+ myConcept.getAvailableAmalgamFcts());

        // just a retrieval
        Retrieval r = new Retrieval(myConcept, cb);
        LinkedList<Double> results;

        try {
            Instance query = r.getQueryInstance();

//			Instance caze = myConcept.getInstance("Case #8");
//
//			for (Map.Entry<AttributeDesc, Attribute> e : caze.getAttributes()
//					.entrySet()) {
//				query.addAttribute(e.getKey(), e.getValue());
//			}

            String attStr = "Exercise #22;Exercise #23;Exercise #27;Exercise #11;Exercise #32;Exercise #7;Exercise #0";
            System.out.println("############################# Query extras: " + attStr);

            LinkedList<de.dfki.mycbr.core.casebase.Attribute> llAtts = new LinkedList<de.dfki.mycbr.core.casebase.Attribute>();
            ConceptDesc exerciseLst = (ConceptDesc) myConcept.getAttributeDesc("Exercise_list");

            StringTokenizer st = new StringTokenizer(attStr, ";");
            while (st.hasMoreElements()) {

                String exerciseName = st.nextElement().toString().trim();
                Instance exercise = exercise_cb.containsCase(exerciseName);
                llAtts.add(exercise);
            }

            MultipleAttribute<ConceptDesc> multiSymbol = new MultipleAttribute<ConceptDesc>(exerciseLst, llAtts);
            query.addAttribute(exerciseLst, multiSymbol);


            r.setRetrievalMethod(Retrieval.RetrievalMethod.RETRIEVE_SORTED);
            r.start();
            List<Pair<Instance, Similarity>> result = r.getResult();
            printResult(result);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
*/

    private static LinkedList<Double> printResult(List<Pair<Instance, Similarity>> result) {
        LinkedList<Double> sims = new LinkedList<Double>();
        for (Pair<Instance, Similarity> r : result) {
            System.out.println("Similarity: " + r.getSecond().getValue()
                    + " to Instance: " + r.getFirst().getName()
                    + "\t\t\t Exercise list: " + r.getFirst().getAttForDesc(myConcept.getAttributeDesc("Exercise_list")));
            sims.add(r.getSecond().getValue());
            //	getInstanceContent(r.getFirst(), r.getSecond());
        }
        return sims;
    }

    private static HashMap<String,String> getInstanceContent(Instance anInstance, Similarity sim){
        HashMap<AttributeDesc, de.dfki.mycbr.core.casebase.Attribute> atts = anInstance.getAttributes();

        System.out.println("Instance content: ");
        System.out.println("\t\tSimilarity: " + sim.getRoundedValue());

        for (HashMap.Entry<AttributeDesc, de.dfki.mycbr.core.casebase.Attribute> entry : atts.entrySet())
        {
            System.out.println("\t\t" +entry.getKey().getName() + ": " + entry.getValue().getValueAsString());
        }

        return null;
    }
}
